package com.fjhx.emums;

import com.fjhx.client.ClientAbstract;
import com.fjhx.client.impl.ModbusTcpClient;
import com.fjhx.client.impl.OpcUaClient;
import com.fjhx.entity.ConnectConfig;
import lombok.Getter;
import lombok.SneakyThrows;

/**
 * 协议枚举
 */
@Getter
public enum AgreementEnum {

    OpcUa(OpcUaClient.class),
    ModbusTcp(ModbusTcpClient.class);

    private final Class<? extends ClientAbstract> clientClass;

    AgreementEnum(Class<? extends ClientAbstract> clientClass) {
        this.clientClass = clientClass;
    }

    /**
     * 获取链接
     */
    @SneakyThrows
    public ClientAbstract getClient(ConnectConfig connectConfig) {
        return clientClass.getDeclaredConstructor(ConnectConfig.class).newInstance(connectConfig);
    }

}
