package com.fjhx.utils;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.IoUtil;
import cn.hutool.core.util.ObjectUtil;
import com.fjhx.MyMain;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.util.Date;

public class MyUtil {

    // 程序存放地址
    public static final String dir = System.getProperty("user.dir");

    public static final String DATE_TIME_FORMAT = "yyyy-MM-dd HH:mm:ss.SSS";
    public static final String TIME_FORMAT = "HH:mm:ss.SSS";
    public static final String DATE_FORMAT = "yyyy-MM-dd";

    public static void sleep(long l) {
        try {
            Thread.sleep(l);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    /**
     * info级别日志
     */
    public static void infoLog(String jsonStr) {
        write(jsonStr, "log\\info");
    }

    /**
     * error级别日志
     */
    public static void errorLog(String jsonStr) {
        write(jsonStr, "log\\error");
    }

    /**
     * 写入本地数据
     *
     * @param text     写入数据
     * @param pathName 写入路径
     */
    private static void write(String text, String pathName) {
        String path = dir + "\\" + pathName;
        File file = new File(path);
        if (!file.exists()) {
            boolean mkdirs = file.mkdirs();
            if (!mkdirs) {
                System.out.println("文件夹创建失败");
                return;
            }
        }

        Date date = new Date();
        OutputStreamWriter osw = null;
        FileOutputStream fos = null;
        try {
            String filePath = path + "\\" + DateUtil.format(date, DATE_FORMAT) + ".log";
            fos = new FileOutputStream(filePath, true);
            osw = new OutputStreamWriter(fos);

            text = " =====》 " + text;
            System.out.println(DateUtil.format(date, DATE_TIME_FORMAT) + text);

            if (MyMain.config == null || ObjectUtil.equals(MyMain.config.getDebug(), 1)) {
                osw.write(DateUtil.format(date, TIME_FORMAT) + text + "\r\n");
            }

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            IoUtil.close(osw);
            IoUtil.close(fos);
        }
    }

}
